;												
; LED 3xSA23  7-SEGMENT							
;												
; ATmega8										
; 1 MHz											
;												
; Bernhard.Erfurt@gmx.de						
; 07/2011										
;												


;												
; Anschlussbelegung PINS						
;												
; PB0 ==> s. Belegung							
; PB1 ==> s. Belegung							
; PB2 ==> s. Belegung							
; PB3 ==> s. Belegung							
; PB4 ==> s. Belegung							
; PB5 ==> s. Belegung							
; PB6 ==> s. Belegung							
; PB7 ==> s. Belegung							
;												
; PC0 ==> Fotowiderstand						
; PC1 ==> SENSOR								
; PC2 ==> SENSOR-SPANNUNG						
; PC3 ==> LED-DIGIT-0 (rechts)					
; PC4 ==> LED-DIGIT-1							
; PC5 ==> LED-DIGIT-2							
;												
; PD0 ==> BALKEN-A								
; PD1 ==> BALKEN-B								
; PD2 ==> BALKEN-C								
; PD3 ==> BALKEN-D								
; PD4 ==> BALKEN-E								
; PD5 ==> BALKEN-F								
; PD6 ==> BALKEN-G								
; PD7 ==> BALKEN-PUNKT							
;												


; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT					=1000000			
; TIMER-WERTE (2 hoch 8  minus...)				
.equ TIMERWERT0 			=256-5	
; SENSORBELEGUNG TSIC-206						
.equ SENSOR_EINGANG_PORT	= PINC		; SIGNAL-PORT		
.equ SENSOR_EINGANG_PIN		= 1			; SIGNAL-SPANNUNG	
.equ SENSOR_V_PORT			= PORTC		; SPANNUNG-PORT		
.equ SENSOR_V_PIN			= 2			; SPANNUNG-PIN		
.equ SENSOR_OFFSET			= 0			; OFFSETWERT	
; ERROR-CODE									
.equ ERROR_KURZSCHLUSS1		= 1
.equ ERROR_KURZSCHLUSS2		= 2
.equ ERROR_KEINE_DATEN		= 6			; keine SENSOR Impulse
.equ ERROR_NULL_CHECK		= 10
.equ ERROR_MSB				= 12
.equ ERROR_LSB				= 14
; ZEICHEN-DARSTELLUNG - 7-SEGMENT								
.equ ZAHL_0				=0b00111111	; 0 
.equ ZAHL_1				=0b00000110	; 1 
.equ ZAHL_2				=0b01011011	; 2 
.equ ZAHL_3				=0b01001111	; 3 
.equ ZAHL_4				=0b01100110	; 4 
.equ ZAHL_5				=0b01101101	; 5 
.equ ZAHL_6				=0b01111101	; 6 
.equ ZAHL_7				=0b00000111	; 7 
.equ ZAHL_8				=0b01111111	; 8 
.equ ZAHL_9				=0b01101111	; 9 

.equ ZEICHEN_AUS		=0b00000000	; ''
.equ ZEICHEN_PUNKT		=0b10000000	; . 
.equ ZEICHEN_VOLL		=0b11111111	; 8.
.equ ZEICHEN_MINUS		=0b01000000	; - 
.equ ZEICHEN_GRD		=0b01100011	;  

.equ ZEICHEN_A			=0b01110111	; A 
.equ ZEICHEN_B			=0b01111100	; B 
.equ ZEICHEN_C			=0b00111001	; C 
.equ ZEICHEN_D			=0b01011110	; D 
.equ ZEICHEN_E			=0b01111001	; E 
.equ ZEICHEN_F			=0b01110001	; F 
.equ ZEICHEN_P			=0b01110011	; P

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					= 0x0060			; 0x0060 START Adresse 		

.equ adr_ERROR					=0x0060+8			; ERROR-CODE				

.equ adr_STROBE					=0x0060+9			; SENSOR-STROBE				

.equ adr_TEMPERATURDATEN_L		=0x0060+10			; SENSOR-DATENWERT			
.equ adr_TEMPERATURDATEN_H		=0x0060+11

.equ adr_TEMPERATUR_L        	=0x0060+14
.equ adr_TEMPERATUR_H        	=0x0060+15

.equ adr_DUNKELWERT				=0x0060+16

.equ adr_ADC_0_L				=0x0060+50
.equ adr_ADC_0_H				=0x0060+51
.equ adr_ADC_1_L				=0x0060+52
.equ adr_ADC_1_H				=0x0060+53
.equ adr_ADC_2_L				=0x0060+54
.equ adr_ADC_2_H				=0x0060+55
.equ adr_ADC_3_L				=0x0060+56
.equ adr_ADC_3_H				=0x0060+57
.equ adr_ADC_4_L				=0x0060+58
.equ adr_ADC_4_H				=0x0060+59
.equ adr_ADC_5_L				=0x0060+60
.equ adr_ADC_5_H				=0x0060+61




.equ adr_LED_DIGIT_ZAEHLER		= 0x0060+90

.equ adr_LED_BYTE_0				= 0x0060+100		; DIGIT (rechts)
.equ adr_LED_BYTE_1				= 0x0060+101
.equ adr_LED_BYTE_2				= 0x0060+102
.equ adr_LED_BYTE_3				= 0x0060+103
.equ adr_LED_BYTE_4				= 0x0060+104
.equ adr_LED_BYTE_5				= 0x0060+105
.equ adr_LED_BYTE_6				= 0x0060+106
.equ adr_LED_BYTE_7				= 0x0060+107

; EEPROM-BELEGUNG ATmega8						
.equ EEPROM_ADRESSE_TWI			= 0


; REGISTER										

.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler           	
rjmp TIM0_OVF   		; Timer0 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI      ; Two-wire Serial Interface Handler 					
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	wdr	
INTERRUPT_ERROR_SCHLEIFE:
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	


; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	; 
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000100	; LED/V-TSIC/TSIC/FOTOW	
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000	; 
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000	; 
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; 
	out PORTD, temp				
; PORTS fr 7-SEGMENT								
	sbi PORT_DDR_DIG_1,PIN_DIG_1
	sbi PORT_DDR_DIG_2,PIN_DIG_2
	sbi PORT_DDR_DIG_3,PIN_DIG_3
	sbi PORT_DDR_DIG_4,PIN_DIG_4
	sbi PORT_DDR_DIG_5,PIN_DIG_5
	sbi PORT_DDR_DIG_6,PIN_DIG_6
	sbi PORT_DDR_DIG_7,PIN_DIG_7
	sbi PORT_DDR_DIG_8,PIN_DIG_8


	sbi PORT_DDR_BALKEN_A,PIN_BALKEN_A
	sbi PORT_DDR_BALKEN_B,PIN_BALKEN_B
	sbi PORT_DDR_BALKEN_C,PIN_BALKEN_C
	sbi PORT_DDR_BALKEN_D,PIN_BALKEN_D
	sbi PORT_DDR_BALKEN_E,PIN_BALKEN_E
	sbi PORT_DDR_BALKEN_F,PIN_BALKEN_F
	sbi PORT_DDR_BALKEN_G,PIN_BALKEN_G
	sbi PORT_DDR_BALKEN_P,PIN_BALKEN_P

; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
; NEUSTART_MIT_WDR									
;	rcall NEUSTART_MIT_WDR

; ADC_INITIALISIERUNG								
	rcall ADC_INITIALISIERUNG
	rcall ADC_REFERENZ_ON
; TIMER0_INITIALISIERUNG							
	rcall TIMER0_INITIALISIERUNG
; TIMER_AKTIVIEREN									
	rcall TIMER_AKTIVIEREN
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; DUNKELWERT		
	ldi temp,3
	STS(adr_DUNKELWERT),temp
	; ERROR-CODE		
	ldi temp,0
	STS(adr_ERROR),temp
; LED-TEST							
	rcall LED_TEST
	rcall wait_1s
; interrupts freigeben								
	sei
	rcall LED_STRICH
	rcall wait_1s
	rcall SENSOR_TSIC_ABFRAGEN
	rcall ANZEIGE_TEMPERATUR
	rcall wait_1s
	rcall ANZEIGE_ERROR
	rcall wait_1s
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR		; Watch-Dog-RESET	
	rcall MESSEN_0
	rcall BERECHNUNG_HELLIGKEIT
	rcall SENSOR_TSIC_ABFRAGEN
	rcall ANZEIGE_TEMPERATUR
	rcall wait_100ms
	rcall ANZEIGE_ERROR
	;rcall ANZEIGE_STROBE
	;rcall ANZEIGE_DUNKELWERT
;rjmp LOOP

	rcall wait_10s
	rcall MESSEN_0
	rcall BERECHNUNG_HELLIGKEIT

	rcall wait_10s
	rcall MESSEN_0
	rcall BERECHNUNG_HELLIGKEIT

	rcall wait_10s
	rcall MESSEN_0
	rcall BERECHNUNG_HELLIGKEIT


	rcall wait_10s
	rcall MESSEN_0
	rcall BERECHNUNG_HELLIGKEIT

	rcall wait_10s
	rcall MESSEN_0
	rcall BERECHNUNG_HELLIGKEIT

	rcall wait_10s
	rcall MESSEN_0
	rcall BERECHNUNG_HELLIGKEIT
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_HELLIGKEIT:


	LDS temp1,(adr_ADC_0_L)
	LDS temp2,(adr_ADC_0_H)

	; durch 2
	LSR temp2	; :2
	ROR temp1

	; durch 2
	LSR temp2	; :2
	ROR temp1

	cpi temp1,200
	brsh BERECHNUNG_HELLIGKEIT_MIN
	brlo BERECHNUNG_HELLIGKEIT_MAX

BERECHNUNG_HELLIGKEIT_MIN:
	; speichern
	ldi temp1,70
	STS(adr_DUNKELWERT),temp1
	ret
BERECHNUNG_HELLIGKEIT_MAX:
	; speichern
	ldi temp1,3
	STS(adr_DUNKELWERT),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "LED3_LED.asm"
.include "LED3_TIMER.asm"
.include "LED3_SONSTIGES.asm"
.include "LED3_BELEGUNG3.asm"
.include "LED3_ADC.asm"
.include "LED3_TSIC206.asm"


